//+------------------------------------------------------------------+
//|                                                   MT5 Tetris.mq5 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include "MT5_TetrisField.mqh"
//---
#define KEY_NUMPAD_5       12
#define KEY_LEFT           37
#define KEY_UP             38
#define KEY_RIGHT          39
#define KEY_DOWN           40
#define KEY_NUMLOCK_DOWN   98
#define KEY_NUMLOCK_LEFT  100
#define KEY_NUMLOCK_5     101
#define KEY_NUMLOCK_RIGHT 102
#define KEY_NUMLOCK_UP    104
//---
CTetrisField ExtField;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnInit()
  {
//---
   ExtField.Init();
   ChartRedraw();
//---
   EventSetTimer(1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit()
  {
   EventKillTimer();
   ExtField.Deinit();
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(int id, long& lparam, double& dparam, string& sparam)
  {
   long ldparam=dparam;
//   printf("id=%d lparam=%I64d  dparam=%I64d",id,lparam,ldparam);
   if(id==CHARTEVENT_KEYDOWN)
     {
      //printf("%I64d",lparam);
      switch(lparam)
        {
         case KEY_NUMLOCK_LEFT:
         case KEY_LEFT:          ExtField.Left();   break;
         case KEY_NUMLOCK_UP:
         case KEY_UP:            ExtField.Rotate(); break;
         case KEY_NUMLOCK_RIGHT:
         case KEY_RIGHT:         ExtField.Right();  break;
         case KEY_NUMLOCK_DOWN:
         case KEY_DOWN:          ExtField.Down();   break;
         case KEY_NUMPAD_5:
         case KEY_NUMLOCK_5:     ExtField.Drop();   break;
        }
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnTimer()
  {
   ExtField.Down();
   ChartRedraw();
//----
   return(0);
  }
//+------------------------------------------------------------------+
